/* Stolen from ekg2 code,
 * (c) by by Wojtek Kaniewski, Dawid Jarosz */

#ifndef __EKG_DYNSTUFF_H
#define __EKG_DYNSTUFF_H

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#define __USE_SVID
#define __EXTENSIONS__
#include <string.h>

void oom_handler();
void *xcalloc(size_t nmemb, size_t size);
void *xmalloc(size_t size);
void xfree(void *ptr);
void xfreen(void *ptr);
void *xrealloc(void *ptr, size_t size);
char *xstrdup(const char *s);
size_t xstrlen(const char *s);
size_t xstrnlen(const char *s, size_t n); 
char *xstrndup(const char *s, size_t n);
char *xstrcpy(char *dest, const char *src);
char *xstrncpy(char *dest, const char *src, size_t n);
char *xstrchr(char *s, char c);

/*
 * typedef list_t
 *
 * list_t jest prostym typem listy uywanej w praktycznie wszystkich
 * dynamicznych strukturach ekg. obecnie jest to lista jednokierunkowa
 * (pole `prev' jest rwne NULL), ale zostawiono moliwo rozbudowy
 * do dwukierunkowej bez zmiany ABI. dane s przechowywane w polu `data',
 * kolejny element w `next'. przykadowy kod iteracji:
 *
 *     list_t l;
 *
 *     for (l = lista; l; l = l->next) {
 *         struct cokolwiek *c = l->data;
 *         printf("%s\n", c->cokolwiek);
 *     }
 *
 * wikszo list wystpujcych w ekg mona iterowa bez obawy o zmiany
 * ABI. pierwsze pole, bdce jednoznacznym identyfikatorem elementu listy
 * jest dostpne bezporednio, reszta przez odpowiednie funkcje.
 */

struct list {
	void *data;
	struct list *prev;
	struct list *next;
};

typedef struct list *list_t;

void *list_add(list_t *list, void *data, int alloc_size);
void *list_add_sorted(list_t *list, void *data, int alloc_size, int (*comparision)(void *, void *), int dont_allow_dups);
int list_remove(list_t *list, void *data, int free_data);
int list_count(list_t list);
int list_destroy(list_t list, int free_data);

#endif
